import { DataType } from "./DataType";
import { AbstractConstructor } from "./types";
export interface ObjectMetadata {
    id: string;
    fields: ObjectFieldMetadata[];
    constructorDependencies?: {
        ctor: AbstractConstructor<any>;
        required: boolean;
    }[];
}
export interface ObjectFieldMetadata {
    /**
     * Field logic name.
     */
    name: string;
    /**
     * Nested metadata
     */
    elementDto?: ObjectMetadata;
    /**
     * The data type of the field.
     */
    dataType: DataType;
    /**
     * Description of field.
     */
    description?: string;
    /**
     * The value supplied to this field must not be undefined. Null is accepted as a value.
     */
    isRequired?: boolean;
    /**
     * Class constructor or abstract constructor of the injection candidate.
     */
    injecteeSuperClass?: Function & {
        prototype: any;
    };
}
